<?php

declare(strict_types=1);

namespace App\Repository;

final class TblRepresentanteRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblRepresentanteId): object
    {
        $query = 'SELECT * FROM `TblRepresentante` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRepresentanteId);
        $statement->execute();
        $TblRepresentante = $statement->fetchObject();
        if (! $TblRepresentante) {
            throw new \Exception('TblRepresentante not found.', 404);
        }

        return $TblRepresentante;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblRepresentante` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblRepresentante): object
    {
        $query = 'INSERT INTO `TblRepresentante` (`IdSupervisor`, `NombreCompleto`, `IdPais`, `Codigo`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdSupervisor, :NombreCompleto, :IdPais, :Codigo, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblRepresentante->id);
//         $statement->bindParam('fecha', $TblRepresentante->fecha);
        $statement->bindParam('IdSupervisor', $TblRepresentante->IdSupervisor);
        $statement->bindParam('NombreCompleto', $TblRepresentante->NombreCompleto);
        $statement->bindParam('IdPais', $TblRepresentante->IdPais);
        $statement->bindParam('Codigo', $TblRepresentante->Codigo);
        $statement->bindParam('field1', $TblRepresentante->field1);
        $statement->bindParam('field2', $TblRepresentante->field2);
        $statement->bindParam('field3', $TblRepresentante->field3);
        $statement->bindParam('field4', $TblRepresentante->field4);
        $statement->bindParam('field5', $TblRepresentante->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblRepresentante, object $data): object
    {
        if (isset($data->fecha)) {
            $TblRepresentante->fecha = $data->fecha;
        }
        if (isset($data->IdSupervisor)) {
            $TblRepresentante->IdSupervisor = $data->IdSupervisor;
        }
        if (isset($data->NombreCompleto)) {
            $TblRepresentante->NombreCompleto = $data->NombreCompleto;
        }
        if (isset($data->IdPais)) {
            $TblRepresentante->IdPais = $data->IdPais;
        }
        if (isset($data->Codigo)) {
            $TblRepresentante->Codigo = $data->Codigo;
        }
        if (isset($data->field1)) {
            $TblRepresentante->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblRepresentante->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblRepresentante->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblRepresentante->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblRepresentante->field5 = $data->field5;
        }

        $query = 'UPDATE `TblRepresentante` SET `fecha` = :fecha, `IdSupervisor` = :IdSupervisor, `NombreCompleto` = :NombreCompleto, `IdPais` = :IdPais, `Codigo` = :Codigo, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRepresentante->id);
        $statement->bindParam('fecha', $TblRepresentante->fecha);
        $statement->bindParam('IdSupervisor', $TblRepresentante->IdSupervisor);
        $statement->bindParam('NombreCompleto', $TblRepresentante->NombreCompleto);
        $statement->bindParam('IdPais', $TblRepresentante->IdPais);
        $statement->bindParam('Codigo', $TblRepresentante->Codigo);
        $statement->bindParam('field1', $TblRepresentante->field1);
        $statement->bindParam('field2', $TblRepresentante->field2);
        $statement->bindParam('field3', $TblRepresentante->field3);
        $statement->bindParam('field4', $TblRepresentante->field4);
        $statement->bindParam('field5', $TblRepresentante->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblRepresentante->id);
    }

    public function delete(int $TblRepresentanteId): void
    {
        $query = 'DELETE FROM `TblRepresentante` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRepresentanteId);
        $statement->execute();
    }
}
